import 'package:flutter/material.dart';

import '../aideal/pagetypes.dart';

class NavigationPage extends StatefulWidget {
  const NavigationPage({Key? key}) : super(key: key);
  static const routeName = '/navigation';

  @override
  _NavigationState createState() => _NavigationState();
}

class NavigatePageArgs {
  const NavigatePageArgs(this.navigateTo);

  final PageType navigateTo;
}

class _NavigationState extends State<NavigationPage> {
  @override
  Widget build(BuildContext context) {
    final args = ModalRoute.of(context)!.settings.arguments;
    final currentPage = (args! as NavigatePageArgs).navigateTo;

    return Scaffold(
      appBar: AppBar(
        title: Text('Navigation Page'),
      ),
      body: Center(
        child: ListView(
          padding: EdgeInsets.all(8),
          children: <Widget>[
            Text(
              'AiDeal Pages',
              style: TextStyle(
                fontSize: 20,
                height: 1.4,
                color: Colors.teal[200],
                fontWeight: FontWeight.bold,
              ),
            ),
            for (var i = 0; i < PageType.values.length; i++)
              SizedBox(
                height: 44,
                child: ElevatedButton(
                  style: ElevatedButton.styleFrom(
                    primary: Colors.teal[i.isEven ? 100 : 200],
                    onPrimary: Colors.black,
                  ),
                  onPressed: () {
                    Navigator.pushReplacementNamed(
                      context,
                      NavigationPage.routeName,
                      arguments: NavigatePageArgs(PageType.values[i]),
                    );
                  },
                  // child: Text('registration'),
                  child: Text.rich(
                    TextSpan(
                      children: [
                        TextSpan(
                          text: PageType.values[i].name,
                        ),
                        WidgetSpan(
                          child: PageType.values[i] == currentPage
                              ? Icon(
                                  Icons.location_on,
                                  color: Colors.red,
                                )
                              : Icon(null),
                        ),
                      ],
                    ),
                  ),
                ),
              ),
          ],
        ),
      ),
    );
  }
}
